igeo

## Class IParticle

- java.lang.Object
- - igeo.IObject
  - - igeo.IAgent
    - - igeo.IPointAgent
      - - igeo.IParticle

- All Implemented Interfaces:
    IArithmeticVal<IVecI,IDoubleI>, IDynamics, IParameter, IParticleI, ISubobject, ITransformable, IVal, IVecI, IVecOp
  Direct Known Subclasses:
    IBoid, IParticleAgent, IParticleTrajectory

      public class IParticle
      extends IPointAgent
      implements IParticleI

  Class of an agent with IParticleGeo.
  Author:
    Satoru Sugihara

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `IVec` | `frc` only to refer to particle.vel and particle.frc
    `IParticleGeo` | `particle`
    `IVec` | `vel` only to refer to particle.vel and particle.frc

    - ### Fields inherited from class igeo.IPointAgent

      `point, pos, tracker`

    - ### Fields inherited from class igeo.IAgent

      `alive, duration, interactOverridden, localDynamics, parent, targets, time`

    - ### Fields inherited from class igeo.IObject

      `attribute, dynamics, graphics, parameter, server, userData`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IParticle()`
    `IParticle(double x, double y, double z)`
    `IParticle(double x, double y, double z, double vx, double vy, double vz)`
    `IParticle(IGeometry... geometries)`
    `IParticle(IParticle p)`
    `IParticle(IParticleGeo ptcl)`
    `IParticle(IParticleGeo ptcl, IVecI vel)`
    `IParticle(IParticle p, IVecI vel)`
    `IParticle(IVec p)`
    `IParticle(IVecI p)`
    `IParticle(IVecI geometryOrigin, IGeometry... geometries)`
    `IParticle(IVecI p, IVecI vel)`
    `IParticle(IVecI geometryOrigin, IVecI geometryOrientation, IGeometry... geometries)`
    `IParticle(IVec p, IVec vel)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `IVec` | `acc()` get acceleration.
    `IVec` | `acceleration()` get acceleration.
    `IParticle` | `add(double x, double y, double z)`
    `IParticle` | `add(double f, IVecI v)` scale add
    `IParticle` | `add(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IParticle` | `add(IDoubleI f, IVecI v)` scale add
    `IParticle` | `add(IVecI v)`
    `IParticle` | `add(IVecI v, double f)` scale add
    `IParticle` | `add(IVecI v, IDoubleI f)` scale add
    `IParticle` | `addForce(double fx, double fy, double fz)` alias of push
    `IParticle` | `addForce(IVecI f)` alias of push
    `IParticle` | `attach(IGeometry... geometries)` attach geometry object to agent to track its location.
    `IParticle` | `attach(IVecI geometryOrigin, IGeometry... geometries)` attach geometry object to agent to track its location.
    `IParticle` | `attach(IVecI geometryOrigin, IVecI geometryOrientation, IGeometry... geometries)` attach geometry object to agent to track its location.
    `IParticle` | `clr(double dgray)`
    `IParticle` | `clr(double dgray, double dalpha)`
    `IParticle` | `clr(double dr, double dg, double db)`
    `IParticle` | `clr(double dr, double dg, double db, double da)`
    `IParticle` | `clr(float fgray)`
    `IParticle` | `clr(float fgray, float falpha)`
    `IParticle` | `clr(float fr, float fg, float fb)`
    `IParticle` | `clr(float fr, float fg, float fb, float fa)`
    `IParticle` | `clr(IColor c)` to set an object color
    `IParticle` | `clr(IColor c, double alpha)` to set color, with alpha value overwritten
    `IParticle` | `clr(IColor c, float alpha)` to set color, with alpha value overwritten
    `IParticle` | `clr(IColor c, int alpha)` to set color, with alpha value overwritten
    `IParticle` | `clr(int gray)`
    `IParticle` | `clr(int gray, int alpha)`
    `IParticle` | `clr(int r, int g, int b)`
    `IParticle` | `clr(int r, int g, int b, int a)`
    `IParticle` | `clr(IObject o)` to set the same color with the object
    `IParticle` | `cp()` alias of dup()
    `IParticle` | `cp(double x, double y, double z)` cp() is alias of dup().add()
    `IParticle` | `cp(IDoubleI x, IDoubleI y, IDoubleI z)` cp() is alias of dup().add()
    `IParticle` | `cp(IVecI v)` cp() is alias of dup().add()
    `double` | `decay()`
    `IParticle` | `decay(double d)`
    `IParticle` | `div(double v)`
    `IParticle` | `div(IDoubleI v)`
    `IParticle` | `dup()` duplicate object
    `IParticle` | `fix()` IParticleI API
    `boolean` | `fixed()` check if it's fixed
    `IParticle` | `flip()` alias of neg()
    `IVec` | `force()` get force
    `IParticle` | `force(IVecI v)` set force
    `IVec` | `frc()` get force
    `IParticle` | `frc(IVecI v)` set force
    `double` | `fric()` get friction
    `IParticle` | `fric(double friction)` set friction
    `double` | `friction()` get friction
    `IParticle` | `friction(double friction)` set friction
    `IParticle` | `hide()`
    `IParticle` | `hideGeometry()` hide attached geometry
    `IParticle` | `hidePoint()`
    `IParticle` | `hsb(double h, double s, double b)`
    `IParticle` | `hsb(double h, double s, double b, double a)`
    `IParticle` | `hsb(float h, float s, float b)`
    `IParticle` | `hsb(float h, float s, float b, float a)`
    `void` | `initParticleAgent()`
    `void` | `initParticleAgent(IParticle ptcl)`
    `void` | `initParticleAgent(IParticleGeo ptcl)`
    `void` | `initParticleAgent(IParticleGeo ptcl, IVecI vel)`
    `void` | `initParticleAgent(IVecI vel)`
    `IParticle` | `layer(ILayer l)` Set layer by ILayer object
    `IParticle` | `len(double l)` setting length
    `IParticle` | `len(IDoubleI l)` setting length
    `double` | `mass()` get mass
    `IParticle` | `mass(double mass)` set mass
    `IParticle` | `mirror(double planeX, double planeY, double planeZ)` alias of ref
    `IParticle` | `mirror(double centerX, double centerY, double centerZ, double planeX, double planeY, double planeZ)` alias of ref
    `IParticle` | `mirror(IVecI planeDir)` alias of ref
    `IParticle` | `mirror(IVecI center, IVecI planeDir)` alias of ref
    `IParticle` | `mul(double v)`
    `IParticle` | `mul(IDoubleI v)`
    `IParticle` | `mv(double x, double y, double z)` mv() is alias of add()
    `IParticle` | `mv(IDoubleI x, IDoubleI y, IDoubleI z)` mv() is alias of add()
    `IParticle` | `mv(IVecI v)` mv() is alias of add()
    `IParticle` | `name(java.lang.String nm)` methods of IObject
    `IParticle` | `neg()`
    `IVec` | `pos()` get position
    `IParticle` | `pos(IVecI v)` set position
    `IVec` | `position()` get position
    `IParticle` | `position(IVecI v)` set position
    `IParticle` | `pull(double fx, double fy, double fz)` equivalent to push(f.dup().neg())
    `IParticle` | `pull(IVecI f)` equivalent to push(f.dup().neg())
    `IParticle` | `push(double fx, double fy, double fz)` adding force to particle
    `IParticle` | `push(IVecI f)` adding force to particle
    `IParticle` | `ref(double planeX, double planeY, double planeZ)` reflect(mirror) 3 dimensionally to the other side of the plane
    `IParticle` | `ref(double centerX, double centerY, double centerZ, double planeX, double planeY, double planeZ)` reflect(mirror) 3 dimensionally to the other side of the plane
    `IParticle` | `ref(IVecI planeDir)` reflect(mirror) 3 dimensionally to the other side of the plane
    `IParticle` | `ref(IVecI center, IVecI planeDir)` reflect(mirror) 3 dimensionally to the other side of the plane
    `IParticle` | `removeTarget(int i)` remove target object.
    `IParticle` | `removeTarget(IObject obj)` remove target object.
    `IParticle` | `reset()` setting force zero
    `IParticle` | `resetForce()` alias of reset
    `IParticle` | `rev()` alias of neg()
    `IParticle` | `rot(double angle)` rotation on XY plane
    `IParticle` | `rot(double axisX, double axisY, double axisZ, double angle)` rotation around axis vector
    `IParticle` | `rot(double centerX, double centerY, double centerZ, double axisX, double axisY, double axisZ, double angle)` rotation around axis vector and center point
    `IParticle` | `rot(IDoubleI angle)` rotation on XY plane
    `IParticle` | `rot(IVecI axis, double angle)` rotation around axis vector
    `IParticle` | `rot(IVecI axis, IDoubleI angle)` rotation around axis vector
    `IParticle` | `rot(IVecI axis, IVecI destDir)` rotate to destination direction vector
    `IParticle` | `rot(IVecI center, IVecI axis, double angle)` rotation around axis vector and center point
    `IParticle` | `rot(IVecI center, IVecI axis, IDoubleI angle)` rotation around axis vector and center point
    `IParticle` | `rot(IVecI center, IVecI axis, IVecI destPt)` rotate to destination point location
    `IParticle` | `rot2(double angle)` rotation on xy-plane; alias of rot(double)
    `IParticle` | `rot2(double centerX, double centerY, double angle)` rotation on xy-plane
    `IParticle` | `rot2(IDoubleI angle)` rotation on xy-plane; alias of rot(IDoubleI)
    `IParticle` | `rot2(IVecI destDir)` rotation on xy-plane towards destDir
    `IParticle` | `rot2(IVecI center, double angle)` rotation on xy-plane
    `IParticle` | `rot2(IVecI center, IDoubleI angle)` rotation on xy-plane
    `IParticle` | `rot2(IVecI center, IVecI destPt)` rotation on xy-plane towards destPt
    `IParticle` | `scale(double f)` alias of mul
    `IParticle` | `scale(double centerX, double centerY, double centerZ, double f)` scale from a center
    `IParticle` | `scale(IDoubleI f)` alias of mul
    `IParticle` | `scale(IVecI center, double f)` scale from a center
    `IParticle` | `scale(IVecI center, IDoubleI f)` scale from a center
    `IParticle` | `scale1d(double axisX, double axisY, double axisZ, double f)` scale only in 1 direction
    `IParticle` | `scale1d(double centerX, double centerY, double centerZ, double axisX, double axisY, double axisZ, double f)` scale only in 1 direction from a center
    `IParticle` | `scale1d(IVecI axis, double f)` scale only in 1 direction
    `IParticle` | `scale1d(IVecI axis, IDoubleI f)` scale only in 1 direction
    `IParticle` | `scale1d(IVecI center, IVecI axis, double f)` scale only in 1 direction from a center
    `IParticle` | `scale1d(IVecI center, IVecI axis, IDoubleI f)` scale only in 1 direction from a center
    `IParticle` | `set(double x, double y, double z)`
    `IParticle` | `set(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IParticle` | `set(IVecI v)`
    `IParticle` | `setColor(double dgray)`
    `IParticle` | `setColor(double dgray, double dalpha)`
    `IParticle` | `setColor(double dr, double dg, double db)`
    `IParticle` | `setColor(double dr, double dg, double db, double da)`
    `IParticle` | `setColor(float fgray)`
    `IParticle` | `setColor(float fgray, float falpha)`
    `IParticle` | `setColor(float fr, float fg, float fb)`
    `IParticle` | `setColor(float fr, float fg, float fb, float fa)`
    `IParticle` | `setColor(IColor c)`
    `IParticle` | `setColor(IColor c, double alpha)`
    `IParticle` | `setColor(IColor c, float alpha)`
    `IParticle` | `setColor(IColor c, int alpha)`
    `IParticle` | `setColor(int gray)`
    `IParticle` | `setColor(int gray, int alpha)`
    `IParticle` | `setColor(int r, int g, int b)`
    `IParticle` | `setColor(int r, int g, int b, int a)`
    `IParticle` | `setHSBColor(double h, double s, double b)`
    `IParticle` | `setHSBColor(double h, double s, double b, double a)`
    `IParticle` | `setHSBColor(float h, float s, float b)`
    `IParticle` | `setHSBColor(float h, float s, float b, float a)`
    `IParticle` | `setSize(double sz)` methods of IPoint
    `IParticle` | `shear(double sxy, double syx, double syz, double szy, double szx, double sxz)` shear operation
    `IParticle` | `shear(IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)` shear operation
    `IParticle` | `shear(IVecI center, double sxy, double syx, double syz, double szy, double szx, double sxz)` shear operation
    `IParticle` | `shear(IVecI center, IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)` shear operation
    `IParticle` | `shearXY(double sxy, double syx)` shear operation on XY
    `IParticle` | `shearXY(IDoubleI sxy, IDoubleI syx)` shear operation on XY
    `IParticle` | `shearXY(IVecI center, double sxy, double syx)` shear operation on XY
    `IParticle` | `shearXY(IVecI center, IDoubleI sxy, IDoubleI syx)` shear operation on XY
    `IParticle` | `shearYZ(double syz, double szy)` shear operation on YZ
    `IParticle` | `shearYZ(IDoubleI syz, IDoubleI szy)` shear operation on YZ
    `IParticle` | `shearYZ(IVecI center, double syz, double szy)` shear operation on YZ
    `IParticle` | `shearYZ(IVecI center, IDoubleI syz, IDoubleI szy)` shear operation on YZ
    `IParticle` | `shearZX(double szx, double sxz)` shear operation on ZX
    `IParticle` | `shearZX(IDoubleI szx, IDoubleI sxz)` shear operation on ZX
    `IParticle` | `shearZX(IVecI center, double szx, double sxz)` shear operation on ZX
    `IParticle` | `shearZX(IVecI center, IDoubleI szx, IDoubleI sxz)` shear operation on ZX
    `IParticle` | `show()`
    `IParticle` | `showGeometry()` show attached geometry
    `IParticle` | `showPoint()`
    `IParticle` | `size(double sz)`
    `boolean` | `skipUpdateOnce()` for other agent to control particle
    `IParticle` | `skipUpdateOnce(boolean f)` for other agent to control particle
    `IParticle` | `sub(double x, double y, double z)`
    `IParticle` | `sub(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IParticle` | `sub(IVecI v)`
    `IParticle` | `target(IObject targetObj)` add terget object to be updated by this dynamic object.
    `IParticle` | `transform(IMatrix3I mat)` transform with a transformation matrix
    `IParticle` | `transform(IMatrix4I mat)` transform with a transformation matrix
    `IParticle` | `transform(IVecI xvec, IVecI yvec, IVecI zvec)` transform with a transformation vectors
    `IParticle` | `transform(IVecI xvec, IVecI yvec, IVecI zvec, IVecI translate)` transform with a transformation vectors
    `IParticle` | `translate(double x, double y, double z)` alias of add()
    `IParticle` | `translate(IDoubleI x, IDoubleI y, IDoubleI z)` alias of add()
    `IParticle` | `translate(IVecI v)` alias of add()
    `IParticle` | `unfix()` unfix movement
    `IParticle` | `unit()` unitize
    `IVec` | `vel()` get velocity
    `IParticle` | `vel(IVecI v)` set velocity
    `IVec` | `velocity()` get velocity
    `IParticle` | `velocity(IVecI v)` set velocity
    `IParticle` | `weight(double w)`
    `IParticle` | `weight(float w)`
    `IParticle` | `x(double vx)` methods of IVecI
    `IParticle` | `x(IDoubleI vx)` setting x component
    `IParticle` | `x(IVec2I v)` setting x component by x component of input vector
    `IParticle` | `x(IVecI v)` setting x component by x component of input vector
    `IParticle` | `y(double vy)` setting y component
    `IParticle` | `y(IDoubleI vy)` setting y component
    `IParticle` | `y(IVec2I v)` setting y component by y component of input vector
    `IParticle` | `y(IVecI v)` setting y component by y component of input vector
    `IParticle` | `z(double vz)` setting z component
    `IParticle` | `z(IDoubleI vz)` setting z component
    `IParticle` | `z(IVecI v)` setting z component by z component of input vector
    `IParticle` | `zero()` setting all zero

    - ### Methods inherited from class igeo.IPointAgent

      `angle, angle, angle, angle, angle, angle, angle, angle, bisect, bisect, brep, brep, brepNum, breps, cross, cross, curve, curve, curveNum, curves, del, del, dif, dif, diff, diff, dist, dist, dist, dist, dist2, dist2, dist2, dist2, dot, dot, dot, dot, eq, eq, eq, eq, eq, eq, eq, eq, eqX, eqX, eqX, eqX, eqX, eqX, eqX, eqX, eqY, eqY, eqY, eqY, eqY, eqY, eqY, eqY, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, geometries, geometry, geometry, geometryNum, get, getSize, getX, getY, getZ, isValid, len, len, len, len2, len2, len2, mesh, mesh, meshes, meshNum, mid, mid, nml, nml, nml, nml, point, point, pointNum, points, size, sum, sum, sum, sum, sum, sum, sum, surface, surface, surfaceNum, surfaces, to2d, to2d, to2d, to2d, to4d, to4d, to4d, toString, x, x, x, y, y, y, z, z, z`

    - ### Methods inherited from class igeo.IAgent

      `addDynamics, alive, deletDynamics, deleteDynamics, deleteDynamics, duration, duration, dynamicsNum, getDynamics, initAgent, interact, interact, localDynamics, parent, parent, postinteract, postupdate, preinteract, preupdate, target, targetNum, targets, time, time, update, updateGraphic, updateTarget`

    - ### Methods inherited from class igeo.IObject

      `addUserData, addUserData, alpha, alphaInt, attr, attr, attr, awtColor, blue, blueInt, brightness, castStringHashMap, clearDynamics, clearGraphics, clr, clr, clr, clr, clr, createGraphic, defaultAttribute, deleteGraphic, getAWTColor, getColor, getGraphic, getGraphic, getParameter, graphicsNum, gray, grayInt, green, greenInt, grey, greyInt, hue, initGraphic, initObject, isVisible, layer, layer, name, red, redInt, resetGraphic, saturation, server, setColor, setColor, setColor, setColor, setParameter, setTexture, syncColor, syncGraphic, syncVisibility, syncWeight, texture, userData, userData, userData, userDataNum, visible, weight`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface igeo.IParticleI

      `target, targetNum, targets, updateTarget`

    - ### Methods inherited from interface igeo.IVecI

      `angle, angle, angle, angle, angle, angle, angle, angle, bisect, bisect, cross, cross, dif, dif, diff, diff, dist, dist, dist, dist, dist2, dist2, dist2, dist2, dot, dot, dot, dot, eq, eq, eq, eq, eq, eq, eq, eq, eqX, eqX, eqX, eqX, eqX, eqX, eqX, eqX, eqY, eqY, eqY, eqY, eqY, eqY, eqY, eqY, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, get, getX, getY, getZ, isValid, len, len, len, len2, len2, len2, mid, mid, nml, nml, nml, nml, sum, sum, sum, sum, sum, sum, sum, to2d, to2d, to2d, to2d, to4d, to4d, to4d, x, x, x, y, y, y, z, z, z`

- - ### Field Detail

    - #### particle

          public IParticleGeo particle

    - #### vel

          public IVec vel

      only to refer to particle.vel and particle.frc

    - #### frc

          public IVec frc

      only to refer to particle.vel and particle.frc

  - ### Constructor Detail

    - #### IParticle

          public IParticle()

    - #### IParticle

          public IParticle(double x,
                           double y,
                           double z)

    - #### IParticle

          public IParticle(IVec p)

    - #### IParticle

          public IParticle(IVecI p)

    - #### IParticle

          public IParticle(IParticleGeo ptcl)

    - #### IParticle

          public IParticle(IParticle p)

    - #### IParticle

          public IParticle(double x,
                           double y,
                           double z,
                           double vx,
                           double vy,
                           double vz)

    - #### IParticle

          public IParticle(IVec p,
                           IVec vel)

    - #### IParticle

          public IParticle(IVecI p,
                           IVecI vel)

    - #### IParticle

          public IParticle(IParticleGeo ptcl,
                           IVecI vel)

    - #### IParticle

          public IParticle(IParticle p,
                           IVecI vel)

    - #### IParticle

          public IParticle(IGeometry... geometries)

    - #### IParticle

          public IParticle(IVecI geometryOrigin,
                           IGeometry... geometries)

    - #### IParticle

          public IParticle(IVecI geometryOrigin,
                           IVecI geometryOrientation,
                           IGeometry... geometries)

  - ### Method Detail

    - #### initParticleAgent

          public void initParticleAgent()

    - #### initParticleAgent

          public void initParticleAgent(IParticleGeo ptcl)

    - #### initParticleAgent

          public void initParticleAgent(IParticle ptcl)

    - #### initParticleAgent

          public void initParticleAgent(IVecI vel)

    - #### initParticleAgent

          public void initParticleAgent(IParticleGeo ptcl,
                                        IVecI vel)

    - #### fix

          public IParticle fix()

      IParticleI API
      Specified by:
        `fix` in interface `IParticleI`

    - #### unfix

          public IParticle unfix()

      Description copied from interface: `IParticleI`
      unfix movement
      Specified by:
        `unfix` in interface `IParticleI`

    - #### fixed

          public boolean fixed()

      check if it's fixed
      Specified by:
        `fixed` in interface `IParticleI`

    - #### skipUpdateOnce

          public IParticle skipUpdateOnce(boolean f)

      for other agent to control particle
      Specified by:
        `skipUpdateOnce` in interface `IParticleI`

    - #### skipUpdateOnce

          public boolean skipUpdateOnce()

      for other agent to control particle
      Specified by:
        `skipUpdateOnce` in interface `IParticleI`

    - #### mass

          public double mass()

      Description copied from interface: `IParticleI`
      get mass
      Specified by:
        `mass` in interface `IParticleI`

    - #### mass

          public IParticle mass(double mass)

      Description copied from interface: `IParticleI`
      set mass
      Specified by:
        `mass` in interface `IParticleI`

    - #### position

          public IVec position()

      Description copied from interface: `IParticleI`
      get position
      Specified by:
        `position` in interface `IParticleI`
      Overrides:
        `position` in class `IPointAgent`

    - #### position

          public IParticle position(IVecI v)

      Description copied from interface: `IParticleI`
      set position
      Specified by:
        `position` in interface `IParticleI`
      Overrides:
        `position` in class `IPointAgent`

    - #### pos

          public IVec pos()

      Description copied from interface: `IParticleI`
      get position
      Specified by:
        `pos` in interface `IParticleI`
      Overrides:
        `pos` in class `IPointAgent`

    - #### pos

          public IParticle pos(IVecI v)

      Description copied from interface: `IParticleI`
      set position
      Specified by:
        `pos` in interface `IParticleI`
      Overrides:
        `pos` in class `IPointAgent`

    - #### velocity

          public IVec velocity()

      Description copied from interface: `IParticleI`
      get velocity
      Specified by:
        `velocity` in interface `IParticleI`

    - #### velocity

          public IParticle velocity(IVecI v)

      Description copied from interface: `IParticleI`
      set velocity
      Specified by:
        `velocity` in interface `IParticleI`

    - #### vel

          public IVec vel()

      Description copied from interface: `IParticleI`
      get velocity
      Specified by:
        `vel` in interface `IParticleI`

    - #### vel

          public IParticle vel(IVecI v)

      Description copied from interface: `IParticleI`
      set velocity
      Specified by:
        `vel` in interface `IParticleI`

    - #### acceleration

          public IVec acceleration()

      Description copied from interface: `IParticleI`
      get acceleration. no method to set acceleration. set force instead
      Specified by:
        `acceleration` in interface `IParticleI`

    - #### acc

          public IVec acc()

      Description copied from interface: `IParticleI`
      get acceleration. no method to set acceleration. set force instead
      Specified by:
        `acc` in interface `IParticleI`

    - #### force

          public IVec force()

      Description copied from interface: `IParticleI`
      get force
      Specified by:
        `force` in interface `IParticleI`

    - #### force

          public IParticle force(IVecI v)

      Description copied from interface: `IParticleI`
      set force
      Specified by:
        `force` in interface `IParticleI`

    - #### frc

          public IVec frc()

      Description copied from interface: `IParticleI`
      get force
      Specified by:
        `frc` in interface `IParticleI`

    - #### frc

          public IParticle frc(IVecI v)

      Description copied from interface: `IParticleI`
      set force
      Specified by:
        `frc` in interface `IParticleI`

    - #### friction

          public double friction()

      Description copied from interface: `IParticleI`
      get friction
      Specified by:
        `friction` in interface `IParticleI`

    - #### friction

          public IParticle friction(double friction)

      Description copied from interface: `IParticleI`
      set friction
      Specified by:
        `friction` in interface `IParticleI`

    - #### fric

          public double fric()

      Description copied from interface: `IParticleI`
      get friction
      Specified by:
        `fric` in interface `IParticleI`

    - #### fric

          public IParticle fric(double friction)

      Description copied from interface: `IParticleI`
      set friction
      Specified by:
        `fric` in interface `IParticleI`

    - #### decay

          public double decay()

      Specified by:
        `decay` in interface `IParticleI`

    - #### decay

          public IParticle decay(double d)

      Specified by:
        `decay` in interface `IParticleI`

    - #### push

          public IParticle push(IVecI f)

      Description copied from interface: `IParticleI`
      adding force to particle
      Specified by:
        `push` in interface `IParticleI`

    - #### push

          public IParticle push(double fx,
                                double fy,
                                double fz)

      Description copied from interface: `IParticleI`
      adding force to particle
      Specified by:
        `push` in interface `IParticleI`

    - #### pull

          public IParticle pull(IVecI f)

      Description copied from interface: `IParticleI`
      equivalent to push(f.dup().neg())
      Specified by:
        `pull` in interface `IParticleI`

    - #### pull

          public IParticle pull(double fx,
                                double fy,
                                double fz)

      Description copied from interface: `IParticleI`
      equivalent to push(f.dup().neg())
      Specified by:
        `pull` in interface `IParticleI`

    - #### addForce

          public IParticle addForce(IVecI f)

      Description copied from interface: `IParticleI`
      alias of push
      Specified by:
        `addForce` in interface `IParticleI`

    - #### addForce

          public IParticle addForce(double fx,
                                    double fy,
                                    double fz)

      Description copied from interface: `IParticleI`
      alias of push
      Specified by:
        `addForce` in interface `IParticleI`

    - #### reset

          public IParticle reset()

      Description copied from interface: `IParticleI`
      setting force zero
      Specified by:
        `reset` in interface `IParticleI`

    - #### resetForce

          public IParticle resetForce()

      Description copied from interface: `IParticleI`
      alias of reset
      Specified by:
        `resetForce` in interface `IParticleI`

    - #### attach

          public IParticle attach(IGeometry... geometries)

      attach geometry object to agent to track its location.
      Overrides:
        `attach` in class `IPointAgent`
      Parameters:
        `geometries` - one or more geometry objects. object's center is moved to the agent's location.

    - #### attach

          public IParticle attach(IVecI geometryOrigin,
                                  IGeometry... geometries)

      attach geometry object to agent to track its location.
      Overrides:
        `attach` in class `IPointAgent`
      Parameters:
        `geometryOrigin` - origin of geometry object which is moved to the agent's location.
        `geometries` - one or more geometry objects.

    - #### attach

          public IParticle attach(IVecI geometryOrigin,
                                  IVecI geometryOrientation,
                                  IGeometry... geometries)

      attach geometry object to agent to track its location.
      Parameters:
        `geometryOrigin` - origin of geometry object which is moved to the agent's location.
        `geometryOrientation` - original orientation of geometry which is matched with particle's velocity direction; if its's null, orientatin matching is disabled.
        `geometries` - one or more geometry objects.

    - #### x

          public IParticle x(double vx)

      methods of IVecI
      Specified by:
        `x` in interface `IVecI`
      Overrides:
        `x` in class `IPointAgent`

    - #### y

          public IParticle y(double vy)

      Description copied from interface: `IVecI`
      setting y component
      Specified by:
        `y` in interface `IVecI`
      Overrides:
        `y` in class `IPointAgent`

    - #### z

          public IParticle z(double vz)

      Description copied from interface: `IVecI`
      setting z component
      Specified by:
        `z` in interface `IVecI`
      Overrides:
        `z` in class `IPointAgent`

    - #### x

          public IParticle x(IDoubleI vx)

      Description copied from interface: `IVecI`
      setting x component
      Specified by:
        `x` in interface `IVecI`
      Overrides:
        `x` in class `IPointAgent`

    - #### y

          public IParticle y(IDoubleI vy)

      Description copied from interface: `IVecI`
      setting y component
      Specified by:
        `y` in interface `IVecI`
      Overrides:
        `y` in class `IPointAgent`

    - #### z

          public IParticle z(IDoubleI vz)

      Description copied from interface: `IVecI`
      setting z component
      Specified by:
        `z` in interface `IVecI`
      Overrides:
        `z` in class `IPointAgent`

    - #### x

          public IParticle x(IVecI v)

      setting x component by x component of input vector
      Specified by:
        `x` in interface `IVecI`
      Overrides:
        `x` in class `IPointAgent`

    - #### y

          public IParticle y(IVecI v)

      setting y component by y component of input vector
      Specified by:
        `y` in interface `IVecI`
      Overrides:
        `y` in class `IPointAgent`

    - #### z

          public IParticle z(IVecI v)

      setting z component by z component of input vector
      Specified by:
        `z` in interface `IVecI`
      Overrides:
        `z` in class `IPointAgent`

    - #### x

          public IParticle x(IVec2I v)

      setting x component by x component of input vector
      Specified by:
        `x` in interface `IVecI`
      Overrides:
        `x` in class `IPointAgent`

    - #### y

          public IParticle y(IVec2I v)

      setting y component by y component of input vector
      Specified by:
        `y` in interface `IVecI`
      Overrides:
        `y` in class `IPointAgent`

    - #### dup

          public IParticle dup()

      Description copied from class: `IObject`
      duplicate object
      Specified by:
        `dup` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `dup` in interface `ITransformable`
      Specified by:
        `dup` in interface `IVecI`
      Overrides:
        `dup` in class `IPointAgent`

    - #### set

          public IParticle set(IVecI v)

      Specified by:
        `set` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `set` in interface `IVecI`
      Overrides:
        `set` in class `IPointAgent`

    - #### set

          public IParticle set(double x,
                               double y,
                               double z)

      Specified by:
        `set` in interface `IVecI`
      Overrides:
        `set` in class `IPointAgent`

    - #### set

          public IParticle set(IDoubleI x,
                               IDoubleI y,
                               IDoubleI z)

      Specified by:
        `set` in interface `IVecI`
      Overrides:
        `set` in class `IPointAgent`

    - #### add

          public IParticle add(double x,
                               double y,
                               double z)

      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IPointAgent`

    - #### add

          public IParticle add(IDoubleI x,
                               IDoubleI y,
                               IDoubleI z)

      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IPointAgent`

    - #### add

          public IParticle add(IVecI v)

      Specified by:
        `add` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IPointAgent`

    - #### sub

          public IParticle sub(double x,
                               double y,
                               double z)

      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in interface `IVecI`
      Overrides:
        `sub` in class `IPointAgent`

    - #### sub

          public IParticle sub(IDoubleI x,
                               IDoubleI y,
                               IDoubleI z)

      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in interface `IVecI`
      Overrides:
        `sub` in class `IPointAgent`

    - #### sub

          public IParticle sub(IVecI v)

      Specified by:
        `sub` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in interface `IVecI`
      Overrides:
        `sub` in class `IPointAgent`

    - #### mul

          public IParticle mul(IDoubleI v)

      Specified by:
        `mul` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `mul` in interface `ITransformable`
      Specified by:
        `mul` in interface `IVecI`
      Overrides:
        `mul` in class `IPointAgent`

    - #### mul

          public IParticle mul(double v)

      Specified by:
        `mul` in interface `ITransformable`
      Specified by:
        `mul` in interface `IVecI`
      Overrides:
        `mul` in class `IPointAgent`

    - #### div

          public IParticle div(IDoubleI v)

      Specified by:
        `div` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `div` in interface `ITransformable`
      Specified by:
        `div` in interface `IVecI`
      Overrides:
        `div` in class `IPointAgent`

    - #### div

          public IParticle div(double v)

      Specified by:
        `div` in interface `ITransformable`
      Specified by:
        `div` in interface `IVecI`
      Overrides:
        `div` in class `IPointAgent`

    - #### neg

          public IParticle neg()

      Specified by:
        `neg` in interface `ITransformable`
      Specified by:
        `neg` in interface `IVecI`
      Overrides:
        `neg` in class `IPointAgent`

    - #### rev

          public IParticle rev()

      Description copied from interface: `IVecI`
      alias of neg()
      Specified by:
        `rev` in interface `IVecI`
      Overrides:
        `rev` in class `IPointAgent`

    - #### flip

          public IParticle flip()

      Description copied from interface: `IVecI`
      alias of neg()
      Specified by:
        `flip` in interface `ITransformable`
      Specified by:
        `flip` in interface `IVecI`
      Overrides:
        `flip` in class `IPointAgent`

    - #### zero

          public IParticle zero()

      Description copied from interface: `IVecI`
      setting all zero
      Specified by:
        `zero` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `zero` in interface `IVecI`
      Overrides:
        `zero` in class `IPointAgent`

    - #### add

          public IParticle add(IVecI v,
                               double f)

      Description copied from interface: `IVecI`
      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IPointAgent`

    - #### add

          public IParticle add(IVecI v,
                               IDoubleI f)

      Description copied from interface: `IVecI`
      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IPointAgent`

    - #### add

          public IParticle add(double f,
                               IVecI v)

      Description copied from interface: `IVecI`
      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IPointAgent`

    - #### add

          public IParticle add(IDoubleI f,
                               IVecI v)

      Description copied from interface: `IVecI`
      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IPointAgent`

    - #### len

          public IParticle len(IDoubleI l)

      Description copied from interface: `IVecI`
      setting length
      Specified by:
        `len` in interface `IVecI`
      Overrides:
        `len` in class `IPointAgent`

    - #### len

          public IParticle len(double l)

      Description copied from interface: `IVecI`
      setting length
      Specified by:
        `len` in interface `IVecI`
      Overrides:
        `len` in class `IPointAgent`

    - #### unit

          public IParticle unit()

      Description copied from interface: `IVecI`
      unitize
      Specified by:
        `unit` in interface `IVecI`
      Overrides:
        `unit` in class `IPointAgent`

    - #### rot

          public IParticle rot(IDoubleI angle)

      Description copied from interface: `IVecI`
      rotation on XY plane
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IPointAgent`

    - #### rot

          public IParticle rot(double angle)

      Description copied from interface: `IVecI`
      rotation on XY plane
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IPointAgent`

    - #### rot

          public IParticle rot(IVecI axis,
                               IDoubleI angle)

      Description copied from interface: `IVecI`
      rotation around axis vector
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IPointAgent`

    - #### rot

          public IParticle rot(IVecI axis,
                               double angle)

      Description copied from interface: `IVecI`
      rotation around axis vector
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IPointAgent`

    - #### rot

          public IParticle rot(double axisX,
                               double axisY,
                               double axisZ,
                               double angle)

      Description copied from interface: `IVecI`
      rotation around axis vector
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IPointAgent`

    - #### rot

          public IParticle rot(IVecI center,
                               IVecI axis,
                               double angle)

      Description copied from interface: `IVecI`
      rotation around axis vector and center point
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IPointAgent`

    - #### rot

          public IParticle rot(IVecI center,
                               IVecI axis,
                               IDoubleI angle)

      Description copied from interface: `IVecI`
      rotation around axis vector and center point
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IPointAgent`

    - #### rot

          public IParticle rot(double centerX,
                               double centerY,
                               double centerZ,
                               double axisX,
                               double axisY,
                               double axisZ,
                               double angle)

      Description copied from interface: `IVecI`
      rotation around axis vector and center point
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IPointAgent`

    - #### rot

          public IParticle rot(IVecI axis,
                               IVecI destDir)

      Description copied from interface: `IVecI`
      rotate to destination direction vector
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IPointAgent`

    - #### rot

          public IParticle rot(IVecI center,
                               IVecI axis,
                               IVecI destPt)

      Description copied from interface: `IVecI`
      rotate to destination point location
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IPointAgent`

    - #### rot2

          public IParticle rot2(IDoubleI angle)

      Description copied from interface: `IVecI`
      rotation on xy-plane; alias of rot(IDoubleI)
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IPointAgent`

    - #### rot2

          public IParticle rot2(double angle)

      Description copied from interface: `IVecI`
      rotation on xy-plane; alias of rot(double)
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IPointAgent`

    - #### rot2

          public IParticle rot2(IVecI center,
                                double angle)

      Description copied from interface: `IVecI`
      rotation on xy-plane
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IPointAgent`

    - #### rot2

          public IParticle rot2(IVecI center,
                                IDoubleI angle)

      Description copied from interface: `IVecI`
      rotation on xy-plane
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IPointAgent`

    - #### rot2

          public IParticle rot2(double centerX,
                                double centerY,
                                double angle)

      Description copied from interface: `IVecI`
      rotation on xy-plane
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IPointAgent`

    - #### rot2

          public IParticle rot2(IVecI destDir)

      Description copied from interface: `IVecI`
      rotation on xy-plane towards destDir
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IPointAgent`

    - #### rot2

          public IParticle rot2(IVecI center,
                                IVecI destPt)

      Description copied from interface: `IVecI`
      rotation on xy-plane towards destPt
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IPointAgent`

    - #### scale

          public IParticle scale(IDoubleI f)

      Description copied from interface: `IVecI`
      alias of mul
      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVecI`
      Overrides:
        `scale` in class `IPointAgent`

    - #### scale

          public IParticle scale(double f)

      Description copied from interface: `IVecI`
      alias of mul
      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVecI`
      Overrides:
        `scale` in class `IPointAgent`

    - #### scale

          public IParticle scale(IVecI center,
                                 IDoubleI f)

      Description copied from interface: `IVecI`
      scale from a center
      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVecI`
      Overrides:
        `scale` in class `IPointAgent`

    - #### scale

          public IParticle scale(IVecI center,
                                 double f)

      Description copied from interface: `IVecI`
      scale from a center
      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVecI`
      Overrides:
        `scale` in class `IPointAgent`

    - #### scale

          public IParticle scale(double centerX,
                                 double centerY,
                                 double centerZ,
                                 double f)

      Description copied from interface: `IVecI`
      scale from a center
      Specified by:
        `scale` in interface `IVecI`
      Overrides:
        `scale` in class `IPointAgent`

    - #### scale1d

          public IParticle scale1d(IVecI axis,
                                   double f)

      scale only in 1 direction
      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IPointAgent`

    - #### scale1d

          public IParticle scale1d(IVecI axis,
                                   IDoubleI f)

      Description copied from interface: `IVecI`
      scale only in 1 direction
      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IPointAgent`

    - #### scale1d

          public IParticle scale1d(double axisX,
                                   double axisY,
                                   double axisZ,
                                   double f)

      Description copied from interface: `IVecI`
      scale only in 1 direction
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IPointAgent`

    - #### scale1d

          public IParticle scale1d(IVecI center,
                                   IVecI axis,
                                   double f)

      Description copied from interface: `IVecI`
      scale only in 1 direction from a center
      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IPointAgent`

    - #### scale1d

          public IParticle scale1d(IVecI center,
                                   IVecI axis,
                                   IDoubleI f)

      Description copied from interface: `IVecI`
      scale only in 1 direction from a center
      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IPointAgent`

    - #### scale1d

          public IParticle scale1d(double centerX,
                                   double centerY,
                                   double centerZ,
                                   double axisX,
                                   double axisY,
                                   double axisZ,
                                   double f)

      Description copied from interface: `IVecI`
      scale only in 1 direction from a center
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IPointAgent`

    - #### ref

          public IParticle ref(IVecI planeDir)

      Description copied from interface: `IVecI`
      reflect(mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `ITransformable`
      Specified by:
        `ref` in interface `IVecI`
      Overrides:
        `ref` in class `IPointAgent`

    - #### ref

          public IParticle ref(double planeX,
                               double planeY,
                               double planeZ)

      Description copied from interface: `IVecI`
      reflect(mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `IVecI`
      Overrides:
        `ref` in class `IPointAgent`

    - #### ref

          public IParticle ref(IVecI center,
                               IVecI planeDir)

      Description copied from interface: `IVecI`
      reflect(mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `ITransformable`
      Specified by:
        `ref` in interface `IVecI`
      Overrides:
        `ref` in class `IPointAgent`

    - #### ref

          public IParticle ref(double centerX,
                               double centerY,
                               double centerZ,
                               double planeX,
                               double planeY,
                               double planeZ)

      Description copied from interface: `IVecI`
      reflect(mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `IVecI`
      Overrides:
        `ref` in class `IPointAgent`

    - #### mirror

          public IParticle mirror(IVecI planeDir)

      Description copied from interface: `IVecI`
      alias of ref
      Specified by:
        `mirror` in interface `ITransformable`
      Specified by:
        `mirror` in interface `IVecI`
      Overrides:
        `mirror` in class `IPointAgent`

    - #### mirror

          public IParticle mirror(double planeX,
                                  double planeY,
                                  double planeZ)

      Description copied from interface: `IVecI`
      alias of ref
      Specified by:
        `mirror` in interface `IVecI`
      Overrides:
        `mirror` in class `IPointAgent`

    - #### mirror

          public IParticle mirror(IVecI center,
                                  IVecI planeDir)

      Description copied from interface: `IVecI`
      alias of ref
      Specified by:
        `mirror` in interface `ITransformable`
      Specified by:
        `mirror` in interface `IVecI`
      Overrides:
        `mirror` in class `IPointAgent`

    - #### mirror

          public IParticle mirror(double centerX,
                                  double centerY,
                                  double centerZ,
                                  double planeX,
                                  double planeY,
                                  double planeZ)

      Description copied from interface: `IVecI`
      alias of ref
      Specified by:
        `mirror` in interface `IVecI`
      Overrides:
        `mirror` in class `IPointAgent`

    - #### shear

          public IParticle shear(double sxy,
                                 double syx,
                                 double syz,
                                 double szy,
                                 double szx,
                                 double sxz)

      Description copied from interface: `IVecI`
      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVecI`
      Overrides:
        `shear` in class `IPointAgent`

    - #### shear

          public IParticle shear(IDoubleI sxy,
                                 IDoubleI syx,
                                 IDoubleI syz,
                                 IDoubleI szy,
                                 IDoubleI szx,
                                 IDoubleI sxz)

      Description copied from interface: `IVecI`
      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVecI`
      Overrides:
        `shear` in class `IPointAgent`

    - #### shear

          public IParticle shear(IVecI center,
                                 double sxy,
                                 double syx,
                                 double syz,
                                 double szy,
                                 double szx,
                                 double sxz)

      Description copied from interface: `IVecI`
      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVecI`
      Overrides:
        `shear` in class `IPointAgent`

    - #### shear

          public IParticle shear(IVecI center,
                                 IDoubleI sxy,
                                 IDoubleI syx,
                                 IDoubleI syz,
                                 IDoubleI szy,
                                 IDoubleI szx,
                                 IDoubleI sxz)

      Description copied from interface: `IVecI`
      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVecI`
      Overrides:
        `shear` in class `IPointAgent`

    - #### shearXY

          public IParticle shearXY(double sxy,
                                   double syx)

      Description copied from interface: `IVecI`
      shear operation on XY
      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVecI`
      Overrides:
        `shearXY` in class `IPointAgent`

    - #### shearXY

          public IParticle shearXY(IDoubleI sxy,
                                   IDoubleI syx)

      Description copied from interface: `IVecI`
      shear operation on XY
      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVecI`
      Overrides:
        `shearXY` in class `IPointAgent`

    - #### shearXY

          public IParticle shearXY(IVecI center,
                                   double sxy,
                                   double syx)

      Description copied from interface: `IVecI`
      shear operation on XY
      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVecI`
      Overrides:
        `shearXY` in class `IPointAgent`

    - #### shearXY

          public IParticle shearXY(IVecI center,
                                   IDoubleI sxy,
                                   IDoubleI syx)

      Description copied from interface: `IVecI`
      shear operation on XY
      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVecI`
      Overrides:
        `shearXY` in class `IPointAgent`

    - #### shearYZ

          public IParticle shearYZ(double syz,
                                   double szy)

      Description copied from interface: `IVecI`
      shear operation on YZ
      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVecI`
      Overrides:
        `shearYZ` in class `IPointAgent`

    - #### shearYZ

          public IParticle shearYZ(IDoubleI syz,
                                   IDoubleI szy)

      Description copied from interface: `IVecI`
      shear operation on YZ
      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVecI`
      Overrides:
        `shearYZ` in class `IPointAgent`

    - #### shearYZ

          public IParticle shearYZ(IVecI center,
                                   double syz,
                                   double szy)

      Description copied from interface: `IVecI`
      shear operation on YZ
      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVecI`
      Overrides:
        `shearYZ` in class `IPointAgent`

    - #### shearYZ

          public IParticle shearYZ(IVecI center,
                                   IDoubleI syz,
                                   IDoubleI szy)

      Description copied from interface: `IVecI`
      shear operation on YZ
      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVecI`
      Overrides:
        `shearYZ` in class `IPointAgent`

    - #### shearZX

          public IParticle shearZX(double szx,
                                   double sxz)

      Description copied from interface: `IVecI`
      shear operation on ZX
      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVecI`
      Overrides:
        `shearZX` in class `IPointAgent`

    - #### shearZX

          public IParticle shearZX(IDoubleI szx,
                                   IDoubleI sxz)

      Description copied from interface: `IVecI`
      shear operation on ZX
      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVecI`
      Overrides:
        `shearZX` in class `IPointAgent`

    - #### shearZX

          public IParticle shearZX(IVecI center,
                                   double szx,
                                   double sxz)

      Description copied from interface: `IVecI`
      shear operation on ZX
      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVecI`
      Overrides:
        `shearZX` in class `IPointAgent`

    - #### shearZX

          public IParticle shearZX(IVecI center,
                                   IDoubleI szx,
                                   IDoubleI sxz)

      Description copied from interface: `IVecI`
      shear operation on ZX
      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVecI`
      Overrides:
        `shearZX` in class `IPointAgent`

    - #### translate

          public IParticle translate(double x,
                                     double y,
                                     double z)

      Description copied from interface: `IVecI`
      alias of add()
      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in interface `IVecI`
      Overrides:
        `translate` in class `IPointAgent`

    - #### translate

          public IParticle translate(IDoubleI x,
                                     IDoubleI y,
                                     IDoubleI z)

      Description copied from interface: `IVecI`
      alias of add()
      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in interface `IVecI`
      Overrides:
        `translate` in class `IPointAgent`

    - #### translate

          public IParticle translate(IVecI v)

      Description copied from interface: `IVecI`
      alias of add()
      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in interface `IVecI`
      Overrides:
        `translate` in class `IPointAgent`

    - #### transform

          public IParticle transform(IMatrix3I mat)

      Description copied from interface: `IVecI`
      transform with a transformation matrix
      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVecI`
      Overrides:
        `transform` in class `IPointAgent`

    - #### transform

          public IParticle transform(IMatrix4I mat)

      Description copied from interface: `IVecI`
      transform with a transformation matrix
      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVecI`
      Overrides:
        `transform` in class `IPointAgent`

    - #### transform

          public IParticle transform(IVecI xvec,
                                     IVecI yvec,
                                     IVecI zvec)

      Description copied from interface: `IVecI`
      transform with a transformation vectors
      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVecI`
      Overrides:
        `transform` in class `IPointAgent`

    - #### transform

          public IParticle transform(IVecI xvec,
                                     IVecI yvec,
                                     IVecI zvec,
                                     IVecI translate)

      Description copied from interface: `IVecI`
      transform with a transformation vectors
      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVecI`
      Overrides:
        `transform` in class `IPointAgent`

    - #### mv

          public IParticle mv(double x,
                              double y,
                              double z)

      Description copied from interface: `IVecI`
      mv() is alias of add()
      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in interface `IVecI`
      Overrides:
        `mv` in class `IPointAgent`

    - #### mv

          public IParticle mv(IDoubleI x,
                              IDoubleI y,
                              IDoubleI z)

      Description copied from interface: `IVecI`
      mv() is alias of add()
      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in interface `IVecI`
      Overrides:
        `mv` in class `IPointAgent`

    - #### mv

          public IParticle mv(IVecI v)

      Description copied from interface: `IVecI`
      mv() is alias of add()
      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in interface `IVecI`
      Overrides:
        `mv` in class `IPointAgent`

    - #### cp

          public IParticle cp()

      Description copied from class: `IObject`
      alias of dup()
      Specified by:
        `cp` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVecI`
      Overrides:
        `cp` in class `IPointAgent`

    - #### cp

          public IParticle cp(double x,
                              double y,
                              double z)

      Description copied from interface: `IVecI`
      cp() is alias of dup().add()
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVecI`
      Overrides:
        `cp` in class `IPointAgent`

    - #### cp

          public IParticle cp(IDoubleI x,
                              IDoubleI y,
                              IDoubleI z)

      Description copied from interface: `IVecI`
      cp() is alias of dup().add()
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVecI`
      Overrides:
        `cp` in class `IPointAgent`

    - #### cp

          public IParticle cp(IVecI v)

      Description copied from interface: `IVecI`
      cp() is alias of dup().add()
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVecI`
      Overrides:
        `cp` in class `IPointAgent`

    - #### setSize

          public IParticle setSize(double sz)

      methods of IPoint
      Overrides:
        `setSize` in class `IPointAgent`

    - #### size

          public IParticle size(double sz)

      Overrides:
        `size` in class `IPointAgent`

    - #### name

          public IParticle name(java.lang.String nm)

      methods of IObject
      Overrides:
        `name` in class `IPointAgent`

    - #### layer

          public IParticle layer(ILayer l)

      Description copied from class: `IObject`
      Set layer by ILayer object
      Overrides:
        `layer` in class `IPointAgent`

    - #### show

          public IParticle show()

      Overrides:
        `show` in class `IPointAgent`

    - #### hide

          public IParticle hide()

      Overrides:
        `hide` in class `IPointAgent`

    - #### showPoint

          public IParticle showPoint()

      Overrides:
        `showPoint` in class `IPointAgent`

    - #### hidePoint

          public IParticle hidePoint()

      Overrides:
        `hidePoint` in class `IPointAgent`

    - #### showGeometry

          public IParticle showGeometry()

      Description copied from class: `IPointAgent`
      show attached geometry
      Overrides:
        `showGeometry` in class `IPointAgent`

    - #### hideGeometry

          public IParticle hideGeometry()

      Description copied from class: `IPointAgent`
      hide attached geometry
      Overrides:
        `hideGeometry` in class `IPointAgent`

    - #### clr

          public IParticle clr(IColor c)

      Description copied from class: `IObject`
      to set an object color
      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(IColor c,
                               int alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(IColor c,
                               float alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(IColor c,
                               double alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(IObject o)

      Description copied from class: `IObject`
      to set the same color with the object
      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(int gray)

      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(float fgray)

      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(double dgray)

      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(int gray,
                               int alpha)

      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(float fgray,
                               float falpha)

      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(double dgray,
                               double dalpha)

      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(int r,
                               int g,
                               int b)

      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(float fr,
                               float fg,
                               float fb)

      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(double dr,
                               double dg,
                               double db)

      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(int r,
                               int g,
                               int b,
                               int a)

      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(float fr,
                               float fg,
                               float fb,
                               float fa)

      Overrides:
        `clr` in class `IPointAgent`

    - #### clr

          public IParticle clr(double dr,
                               double dg,
                               double db,
                               double da)

      Overrides:
        `clr` in class `IPointAgent`

    - #### hsb

          public IParticle hsb(float h,
                               float s,
                               float b,
                               float a)

      Overrides:
        `hsb` in class `IPointAgent`

    - #### hsb

          public IParticle hsb(double h,
                               double s,
                               double b,
                               double a)

      Overrides:
        `hsb` in class `IPointAgent`

    - #### hsb

          public IParticle hsb(float h,
                               float s,
                               float b)

      Overrides:
        `hsb` in class `IPointAgent`

    - #### hsb

          public IParticle hsb(double h,
                               double s,
                               double b)

      Overrides:
        `hsb` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(IColor c)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(IColor c,
                                    int alpha)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(IColor c,
                                    float alpha)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(IColor c,
                                    double alpha)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(int gray)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(float fgray)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(double dgray)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(int gray,
                                    int alpha)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(float fgray,
                                    float falpha)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(double dgray,
                                    double dalpha)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(int r,
                                    int g,
                                    int b)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(float fr,
                                    float fg,
                                    float fb)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(double dr,
                                    double dg,
                                    double db)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(int r,
                                    int g,
                                    int b,
                                    int a)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(float fr,
                                    float fg,
                                    float fb,
                                    float fa)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setColor

          public IParticle setColor(double dr,
                                    double dg,
                                    double db,
                                    double da)

      Overrides:
        `setColor` in class `IPointAgent`

    - #### setHSBColor

          public IParticle setHSBColor(float h,
                                       float s,
                                       float b,
                                       float a)

      Overrides:
        `setHSBColor` in class `IPointAgent`

    - #### setHSBColor

          public IParticle setHSBColor(double h,
                                       double s,
                                       double b,
                                       double a)

      Overrides:
        `setHSBColor` in class `IPointAgent`

    - #### setHSBColor

          public IParticle setHSBColor(float h,
                                       float s,
                                       float b)

      Overrides:
        `setHSBColor` in class `IPointAgent`

    - #### setHSBColor

          public IParticle setHSBColor(double h,
                                       double s,
                                       double b)

      Overrides:
        `setHSBColor` in class `IPointAgent`

    - #### weight

          public IParticle weight(double w)

      Overrides:
        `weight` in class `IPointAgent`

    - #### weight

          public IParticle weight(float w)

      Overrides:
        `weight` in class `IPointAgent`

    - #### target

          public IParticle target(IObject targetObj)

      add terget object to be updated by this dynamic object.
      Specified by:
        `target` in interface `IDynamics`
      Specified by:
        `target` in interface `IParticleI`
      Overrides:
        `target` in class `IAgent`

    - #### removeTarget

          public IParticle removeTarget(int i)

      remove target object.
      Specified by:
        `removeTarget` in interface `IDynamics`
      Specified by:
        `removeTarget` in interface `IParticleI`
      Overrides:
        `removeTarget` in class `IAgent`

    - #### removeTarget

          public IParticle removeTarget(IObject obj)

      remove target object.
      Specified by:
        `removeTarget` in interface `IDynamics`
      Specified by:
        `removeTarget` in interface `IParticleI`
      Overrides:
        `removeTarget` in class `IAgent`